<script setup lang="ts">
import { ref, type Ref } from 'vue';
import axios, { type AxiosResponse } from 'axios';
import router from '../router/index'
import { useCookies } from "vue3-cookies";
const { cookies } = useCookies();
const backendURL = import.meta.env.VITE_BACKEND_URL;
let nama_lengkap = ref();
let nomor_telepon = ref();
let email = ref();
let password = ref();
let confirm_password = ref();

async function sendFormFunc(nama_lengkap: Ref, nomor_telepon: Ref, email: Ref, password: Ref) {
    return await axios.post(`${backendURL}/auth/register`, {
        "nama_lengkap": nama_lengkap.value,
        "nomor_telepon": nomor_telepon.value,
        "email": email.value,
        "password": password.value
    });
};

let postMethod = async function () {
    sendFormFunc(nama_lengkap, nomor_telepon, email, password)
        .then((response) => {
            var expires: string;
            var token;
            expires = new Date(Date.now() + (1 * 24 * 60 * 60 * 1000)).toUTCString();
            expires = "; expires=" + expires + "; ";
            token = response.data.token;
            document.cookie = "authorization=" + token + "; " + expires + "path=/";
            cookies.set("role", response.data.role)
            cookies.set("email", response.data.email)
            axios.post(`${backendURL}/otp/send`, {},
                {
                    headers: {
                        'authorization': 'Bearer ' + token
                    }
                }
            ).then((response) => {
                let key = response.data.key;
                expires = new Date(Date.now() + (10 * 60 * 1000)).toUTCString();
                expires = "; expires=" + expires + "; ";
                document.cookie = "key=" + key + "; " + expires + "path=/";
            }).catch((error) => {
                alert(error.response.data.Details);
            });

            // @ts-ignore
            router.push("/otp");
        }).catch((error) => {
            switch (error.response.status) {
                case 409:
                    alert(error.response.data);
                    break;
                case 400:
                    alert(error.response.data);
                    break;
                default:
                    alert("Ada gangguan di server. Silakan coba beberapa saat lagi.")
                    break;
            }
        });
}

let namaLengkapVal = (e: Event) => {
    nama_lengkap.value = (<HTMLInputElement>e?.target).value
}

let nomorTeleponVal = (e: Event) => {
    nomor_telepon.value = (<HTMLInputElement>e?.target).value
}

let emailVal = (e: Event) => {
    email.value = (<HTMLInputElement>e?.target).value
}

let passwordVal = (e: Event) => {
    (<HTMLInputElement>document.getElementById("btn-regis")).disabled = true;
    (<HTMLInputElement>document.getElementById("btn-regis")).setAttribute("style", "background:gray;");
    password.value = (<HTMLInputElement>e?.target).value
}

let confirmPasswordVal = (e: Event) => {
    confirm_password.value = (<HTMLInputElement>e?.target).value
    if (confirm_password.value == password.value) {
        (<HTMLInputElement>document.getElementById("btn-regis")).disabled = false;
        (<HTMLInputElement>document.getElementById("btn-regis")).setAttribute("style", "background: #3BA677;");
        (<HTMLInputElement>document.getElementById("password-verify")).textContent = "";
    } else {
        (<HTMLInputElement>document.getElementById("password-verify")).textContent = "Belum sama. Silakan cek kembali";
    }
}

</script>

<template>
    <div class="text-center animate__animated animate__fadeIn flex flex-col">
        <div class="flex flex-row font-register md:[min-height:94vh] min-h-screen items-stretch">
            <div class="pt-3 px-3 w-full md:basis-1/3 bg-white">
                <p class="text-emerald-500 font-judul-regis-login ml-3 font-medium">
                    Register
                </p>
                <p class="label-regis-login ml-3 mt-3 text-base text-black" style="display:flex;">Buat akun untuk
                    eksplorasi lebih
                    lanjut</p>
                <form @submit.prevent="postMethod">
                    <div class="field">
                        <div class="grid grid-cols-1 pt-3">
                            <div>
                                <p class="label-regis-login text-base">Nama Lengkap*</p>
                                <input id="input-nama" @input="namaLengkapVal" type="text" placeholder="Nama Anda"
                                    required class="bg-white border border-neutral-400 p-2 rounded-2xl w-full mb-3" />
                            </div>
                            <div>
                                <p class="label-regis-login text-base">Nomor Telepon*</p>
                                <input id="input-notelp" @input="nomorTeleponVal" type="number"
                                    placeholder="Nomor Telepon Anda" required
                                    class="bg-white border border-neutral-400 p-2 rounded-2xl w-full mb-3" />
                            </div>
                            <div>
                                <p class="label-regis-login text-base">Email*</p>
                                <input id="input-email" @input="emailVal" type="email"
                                    placeholder="some-email@server.com" required
                                    class="bg-white border border-neutral-400 p-2 rounded-2xl w-full mb-3" />
                            </div>
                            <div>
                                <p class="label-regis-login text-base">Password*</p>
                                <input id="input-password" @input="passwordVal" type="password"
                                    placeholder="Make sure it's secure!" required
                                    class="bg-white border border-neutral-400 p-2 rounded-2xl w-full mb-3" />
                            </div>
                        </div>
                        <div>
                            <p class="label-regis-login text-base">Konfirmasi Password*</p>
                            <input id="input-confirm-password" @input="confirmPasswordVal" type="password"
                                placeholder="Ketik ulang password Anda" required
                                class="bg-white border border-neutral-400 p-2 rounded-2xl w-full mb-3" />
                        </div>
                        <div id="password-verify" class="text-red-500"></div>
                    </div>
                    <button class="bg-green-400 text-white rounded-full p-3 mt-3 w-full hover:bg-green-600"
                        type="submit">Daftar</button>
                </form>
            </div>
            <div id="right-side" class="hidden md:block basis-2/3 right-side-regis-login px-5 py-auto">
                <div class="flex flex-col justify-center h-full">
                    <p class="py-0 my-0" style="color: #FFFFFF;">
                        سَيلاماتْ داتانْࢴْ
                    </p>
                    <p style="color: #FFFFFF;">
                        Pegonizer, solusi cepat dan mudah untuk pegiat Pegon.
                    </p>
                    <p style="color: #FFFFFF;">
                        Cari bentuk lain dari huruf Abjad Pegon dengan fitur Transliterator.
                    </p>
                    <p style="color: #FFFFFF;">
                        Gunakan Katalog Korpus untuk mencari referensi buku dalam Abjad Pegon.
                    </p>
                </div>
            </div>
        </div>
    </div>
</template>
